## rocm-core 6.4.4

=== CMakeLists.txt ===
################################################################################
##
## MIT License
##
## Copyright (c) 2017 - 2023 Advanced Micro Devices, Inc. All rights Reserved.
##
## Permission is hereby granted, free of charge, to any person obtaining a copy
## of this software and associated documentation files (the "Software"), to deal
## in the Software without restriction, including without limitation the rights
## to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
## copies of the Software, and to permit persons to whom the Software is
## furnished to do so, subject to the following conditions:
##
## The above copyright notice and this permission notice shall be included in all
## copies or substantial portions of the Software.
##
## THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
## IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
## FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
## AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
## LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
## OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
## SOFTWARE.
##
################################################################################

cmake_minimum_required( VERSION 3.16 )
set( CORE_TARGET "rocm-core" )

project( ${CORE_TARGET} CXX )

## Define Lib Target Name and Lib Target Install Dir to be available to c++ source
add_definitions( -DTARGET_LIBRARY_NAME=\"${CORE_TARGET}\" -DTARGET_LIBRARY_INSTALL_DIR=\"${CMAKE_INSTALL_LIBDIR}\" )

## Build Type Settings
set( CMAKE_BUILD_TYPE Release CACHE STRING "Choose the type of build, options are: None Debug Release RelWithDebInfo MinSizeRel." )

## Verbose output.
set( CMAKE_VERBOSE_MAKEFILE on )
include( GNUInstallDirs )

if(ENABLE_ASAN_PACKAGING)
  # Only libraries required for ASAN Package
  set( CPACK_COMPONENTS_ALL CORE_ASAN )
  set( COMP_TYPE "CORE_ASAN" )
  set( PKG_DESCRIPTION "ROCm AddressSanitizer Instrumented Runtime software stack" )
  set( CMAKE_INSTALL_DOCDIR "${CMAKE_INSTALL_DOCDIR}-asan" )
else()
  if(BUILD_SHARED_LIBS)
    set( CPACK_COMPONENTS_ALL CORE_RUNTIME )
    set( COMP_TYPE "CORE_RUNTIME" )
    set( PKG_DESCRIPTION "ROCm Runtime software stack" )
  else()
    set( CPACK_COMPONENTS_ALL CORE_STATIC )
    set( STATIC_COMP_TYPE "CORE_STATIC" )
    set( PKG_DESCRIPTION "ROCm Static software stack" )
  endif()
endif()

include( utils.cmake )

#Parse Version
message( STATUS "ROCM_VERSION = ${ROCM_VERSION}" )
parse_rocm_version( ${ROCM_VERSION} )

set( CPACK_PACKAGING_INSTALL_PREFIX "/opt/rocm" CACHE PATH "default cpack directory" )
set( BUILD_SHARED_LIBS ON CACHE BOOL "Build shared library (.so) or not." )
set( CPACK_GENERATOR "TGZ;DEB;RPM" CACHE STRING "package types to be produced " )
set( LICENSE_FILE "${CMAKE_CURRENT_SOURCE_DIR}/copyright" CACHE PATH "Path to License File in source dir" )
set( BUILD_DIR ${CMAKE_CURRENT_BINARY_DIR} )
set( EXTENDED_PACKAGE_DESCRIPTION
     "ROCM-CORE package helps to get ROCm release version,get install path.
     It is also important to note that ROCM-CORE takes the role as a base
     component on which all of ROCm can depend, to make it easy to remove
     all of ROCm with a package manager." )

set( BUILD_ENABLE_LINTIAN_OVERRIDES OFF CACHE BOOL "Enable/Disable Lintian Overrides" )
set( BUILD_DEBIAN_PKGING_FLAG OFF CACHE BOOL "Internal Status Flag to indicate Debian Packaging Build" )
if(NOT ENABLE_ASAN_PACKAGING)
    option(FILE_REORG_BACKWARD_COMPATIBILITY "Enable File Reorg with backward compatibility" OFF)
endif()

## Set variables
set_variables()

set( SO_MAJOR "1")
set( SO_MINOR "0" )

if( NOT DEFINED BUILD_ID )
  set( BUILD_ID "9999")
endif()

#Add the libpatch version if available
if( DEFINED VERSION_POINT )
  set( PACKAGE_BUILD_INFO "${VERSION_MAJOR}.${VERSION_MINOR}.${VERSION_PATCH}.${VERSION_POINT}.${VERSION_COMMIT_COUNT}-${BUILD_ID}-${VERSION_HASH}" )
  message ( STATUS "PACKAGE_BUILD_INFO ${PACKAGE_BUILD_INFO}" )
else ()
  set( PACKAGE_BUILD_INFO "${VERSION_MAJOR}.${VERSION_MINOR}.${VERSION_PATCH}.${VERSION_COMMIT_COUNT}-${BUILD_ID}-${VERSION_HASH}" )
endif()

configure_file( ${CMAKE_CURRENT_SOURCE_DIR}/rocmmod.in ${BUILD_DIR}/rocmmod @ONLY )

# Setting Permission 0755 for pre/post install scripts
configure_file( ${CMAKE_CURRENT_SOURCE_DIR}/rocm-core.postinst ${BUILD_DIR}/postinst
	 FILE_PERMISSIONS OWNER_READ OWNER_WRITE OWNER_EXECUTE GROUP_READ GROUP_EXECUTE WORLD_READ WORLD_EXECUTE @ONLY )
configure_file( ${CMAKE_CURRENT_SOURCE_DIR}/rocm-core.prerm ${BUILD_DIR}/prerm
	 FILE_PERMISSIONS OWNER_READ OWNER_WRITE OWNER_EXECUTE GROUP_READ GROUP_EXECUTE WORLD_READ WORLD_EXECUTE @ONLY )

#Generate BUILD_INFO
configure_file( ${CMAKE_CURRENT_SOURCE_DIR}/rocm_version.h.in ${BUILD_DIR}/rocm_version.h @ONLY )
configure_file( ${CMAKE_CURRENT_SOURCE_DIR}/rocm_getpath.h.in ${BUILD_DIR}/rocm_getpath.h @ONLY )
#File reorg Backward compatibility function
if(NOT WIN32)
    if(FILE_REORG_BACKWARD_COMPATIBILITY)
    # To enabe/disable #error in wrapper header files
        if(NOT DEFINED ROCM_HEADER_WRAPPER_WERROR)
            if(DEFINED ENV{ROCM_HEADER_WRAPPER_WERROR})
                set(ROCM_HEADER_WRAPPER_WERROR "$ENV{ROCM_HEADER_WRAPPER_WERROR}"
                    CACHE STRING "Header wrapper warnings as errors.")
            else()
                set(ROCM_HEADER_WRAPPER_WERROR "OFF" CACHE STRING "Header wrapper warnings as errors.")
            endif()
        endif()

        if(ROCM_HEADER_WRAPPER_WERROR)
            set(deprecated_error 1)
        else()
            set(deprecated_error 0)
        endif()

        include(rocm-core-backward-compat.cmake)
    endif() #FILE_REORG_BACKWARD_COMPATIBILITY
endif()

#Make the rocmlib
set( SRCS rocm_version.cpp rocm_getpath.cpp)
add_library( ${CORE_TARGET} ${SRCS} )

set( CXX_FLAGS ${CXX_FLAGS} -g -fPIC -fvisibility=hidden -W -Wall -Wextra -Wno-unused-parameter -Wformat-security -Wundef -Wshadow -Wpointer-arith -Wcast-qual -Wmissing-declarations -Wredundant-decls -Wunreachable-code -std=c++11 )
set( CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS}  -Wl,-z,nodelete -Wl,-no-undefined" )
target_include_directories( ${CORE_TARGET} PRIVATE ${BUILD_DIR} )
if(BUILD_SHARED_LIBS)
  target_link_libraries( ${CORE_TARGET} PRIVATE dl )
endif()

## Set the VERSION and SOVERSION values
set( SO_VERSION_STRING "${SO_MAJOR}.${SO_MINOR}.${ROCM_LIBPATCH_VERSION}" )
set_property( TARGET ${CORE_TARGET} PROPERTY VERSION "${SO_VERSION_STRING}" )
set_property( TARGET ${CORE_TARGET} PROPERTY SOVERSION "${SO_MAJOR}" )

#Add the libpatch version if available to the version file
if( DEFINED VERSION_POINT )
  file ( WRITE "${CMAKE_CURRENT_BINARY_DIR}/version" "${VERSION_MAJOR}.${VERSION_MINOR}.${VERSION_PATCH}.${VERSION_POINT}-${BUILD_ID}\n" )
else()
  file ( WRITE "${CMAKE_CURRENT_BINARY_DIR}/version" "${VERSION_MAJOR}.${VERSION_MINOR}.${VERSION_PATCH}-${BUILD_ID}\n" )
endif()

## Support for Static and Shared Target Packaging
if(BUILD_SHARED_LIBS)
  install ( FILES ${BUILD_DIR}/version DESTINATION .info COMPONENT CORE_RUNTIME )

  # Target Library needs to installed/packaged to same destination
  # in both ASAN and nonASAN Shared library builds
  install ( TARGETS ${CORE_TARGET} EXPORT rocmCoreTargets DESTINATION ${CMAKE_INSTALL_LIBDIR}
            COMPONENT ${COMP_TYPE} )
  install ( FILES ${BUILD_DIR}/rocm_version.h ${BUILD_DIR}/rocm_getpath.h
            DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/rocm-core
            COMPONENT CORE_RUNTIME )

  install ( PROGRAMS ${CMAKE_CURRENT_SOURCE_DIR}/runpath_to_rpath.py
            DESTINATION ${CMAKE_INSTALL_LIBEXECDIR}/rocm-core
            COMPONENT CORE_RUNTIME )
  install ( FILES ${BUILD_DIR}/rocmmod
            DESTINATION ${CMAKE_INSTALL_LIBDIR}
            COMPONENT CORE_RUNTIME )

else()
  install ( FILES ${BUILD_DIR}/version
            DESTINATION .info
            COMPONENT ${STATIC_COMP_TYPE} )
  install ( TARGETS ${CORE_TARGET}
            EXPORT rocmCoreTargets
            DESTINATION ${CMAKE_INSTALL_LIBDIR}
            COMPONENT ${STATIC_COMP_TYPE} )

  install ( FILES ${BUILD_DIR}/rocm_version.h ${BUILD_DIR}/rocm_getpath.h
            DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/rocm-core
            COMPONENT ${STATIC_COMP_TYPE} )

  install ( FILES ${CMAKE_CURRENT_SOURCE_DIR}/runpath_to_rpath.py
            DESTINATION ${CMAKE_INSTALL_LIBEXECDIR}/rocm-core
            COMPONENT ${STATIC_COMP_TYPE} )
  install ( FILES ${BUILD_DIR}/rocmmod
            DESTINATION ${CMAKE_INSTALL_LIBDIR}
            COMPONENT ${STATIC_COMP_TYPE} )
endif()

## Cmake module config file configurations
set(CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake_modules/" CACHE INTERNAL "Default module path.")

## Export the package for use from the build-tree
## (this registers the build-tree with a global CMake-registry)
export(PACKAGE ${CORE_TARGET})
set(CONF_LIB_DIR "${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_LIBDIR}")

## Create the rocm-core-config.cmake and rocm-core-config-version files
include(CMakePackageConfigHelpers)
set(CONFIG_PACKAGE_INSTALL_DIR ${CONF_LIB_DIR}/cmake/${CORE_TARGET})
set(LIB_INSTALL_DIR  "${CMAKE_INSTALL_LIBDIR}")
set(INCLUDE_INSTALL_DIR  "${CMAKE_INSTALL_INCLUDEDIR}")
set(BIN_INSTALL_DIR  "${CMAKE_INSTALL_BINDIR}")
set(PKG_MAINTAINER_NM  "ROCm Dev Support")
set(PKG_MAINTAINER_EMAIL  "rocm-dev.support@amd.com")

## Generate Config File for rocm-core
configure_package_config_file(
    ${CMAKE_MODULE_PATH}/${CORE_TARGET}-config.cmake.in
    ${BUILD_DIR}/${CORE_TARGET}-config.cmake
    INSTALL_DESTINATION ${CONFIG_PACKAGE_INSTALL_DIR}
    PATH_VARS LIB_INSTALL_DIR INCLUDE_INSTALL_DIR BIN_INSTALL_DIR
)

## Generate config Version File for rocm-core
write_basic_package_version_file(
    ${BUILD_DIR}/${CORE_TARGET}-config-version.cmake
    VERSION "${VERSION_MAJOR}.${VERSION_MINOR}.${VERSION_PATCH}"
    COMPATIBILITY SameMajorVersion)

## Install the rocm-core-config.cmake and rocm-core-config-version.cmake
install(FILES
    "${PROJECT_BINARY_DIR}/${CORE_TARGET}-config.cmake"
    "${PROJECT_BINARY_DIR}/${CORE_TARGET}-config-version.cmake"
    DESTINATION "${CMAKE_INSTALL_LIBDIR}/cmake/${CORE_TARGET}"
    COMPONENT ${COMP_TYPE})

## Install the export set for use with the install-tree
install(EXPORT rocmCoreTargets DESTINATION
    "${CMAKE_INSTALL_LIBDIR}/cmake/${CORE_TARGET}" COMPONENT ${COMP_TYPE})

## Packaging directives
set ( CPACK_PACKAGE_VENDOR "Advanced Micro Devices, Inc." )
set ( CPACK_PACKAGE_VERSION_MAJOR ${VERSION_MAJOR} )
set ( CPACK_PACKAGE_VERSION_MINOR ${VERSION_MINOR} )
set ( CPACK_PACKAGE_VERSION_PATCH ${VERSION_PATCH} )
set ( CPACK_PACKAGE_VERSION "${CPACK_PACKAGE_VERSION_MAJOR}.${CPACK_PACKAGE_VERSION_MINOR}.${CPACK_PACKAGE_VERSION_PATCH}" )
set ( CPACK_PACKAGE_CONTACT "${PKG_MAINTAINER_NM} <${PKG_MAINTAINER_EMAIL}>" )
set ( CPACK_PACKAGE_DESCRIPTION_SUMMARY "${PKG_DESCRIPTION}" )
set ( CPACK_RESOURCE_FILE_LICENSE "${LICENSE_FILE}" )
## packaging variables
if ( DEFINED ROCM_LIBPATCH_VERSION )
  set ( CPACK_PACKAGE_VERSION "${CPACK_PACKAGE_VERSION}.${ROCM_LIBPATCH_VERSION}" )
  message ( STATUS "Using CPACK_PACKAGE_VERSION ${CPACK_PACKAGE_VERSION}" )
endif()

## Debian package specific variables
set ( CPACK_DEB_COMPONENT_INSTALL ON )
set ( CPACK_DEBIAN_CORE_RUNTIME_PACKAGE_NAME "${CORE_TARGET}" )
# ASAN package name
set ( CPACK_DEBIAN_CORE_ASAN_PACKAGE_NAME ${CORE_TARGET}-asan )
# STATIC package name - For Now, No change for static package Name from default
set ( CPACK_DEBIAN_CORE_STATIC_PACKAGE_NAME ${CORE_TARGET} )
message ( STATUS "Using CPACK_DEBIAN_PACKAGE_RELEASE ${CPACK_DEBIAN_PACKAGE_RELEASE}" )
set ( CPACK_DEBIAN_FILE_NAME "DEB-DEFAULT" )

# Debian specific packaging configuration
if(COMP_TYPE)
  configure_debian_pkg( ${CORE_TARGET} ${COMP_TYPE} ${CPACK_PACKAGE_VERSION} ${PKG_MAINTAINER_NM} ${PKG_MAINTAINER_EMAIL} )
elseif(STATIC_COMP_TYPE)

=== debian/changelog ===
rocm-core (6.4.4-1~exp3) unstable; urgency=medium

  * bumping version for new build

 -- Tim Flink <tflink@tirfa.com>  Mon, 15 Dec 2025 20:50:23 -0600

rocm-core (6.4.4-1~exp2) unstable; urgency=medium

  * updates to address review comments
    - fixed naming of librocm-core-dev
    - fixed upstream URLs
    - removed uneeded Build-Depens
    - reworked descriptions
    - removed ppc64le builds
    - fixed build flags
    - build with system compiler instead of hipcc

 -- Tim Flink <Tim.Flink@amd.com>  Tue, 9 Dec 2025 13:21:14 -0700

rocm-core (6.4.4-1~exp1) unstable; urgency=medium

  * Initial package for rocm-core_6.4.4-1

 -- Tim Flink <Tim.Flink@amd.com>  Fri, 26 Sep 2025 19:27:31 -0600

=== debian/control ===
Source: rocm-core
Section: devel
Homepage: https://github.com/ROCm/rocm-core
Priority: optional
Standards-Version: 4.7.2
#Vcs-Browser: https://salsa.debian.org/rocm-team/rocm-core
#Vcs-Git: https://salsa.debian.org/rocm-team/rocm-core.git
Maintainer: Debian ROCm Team <debian-ai@lists.debian.org>
Uploaders: Tim Flink <tflink@tirfa.com>
Build-Depends:
 debhelper-compat (= 13),
 cmake,
Rules-Requires-Root: no

Package: librocm-core1
Section: libs
Architecture: amd64 arm64
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
Description: provides methods to get information about installed ROCm
 rocm-core can be used to get a ROCm release version in addition to other
 base information like install path.
 .
 rocm-core is not used by all ROCm components and may not provide an accurate
 value for versions if the other component packages are not updated at the
 same time.

Package: librocm-core-dev
Section: libdevel
Architecture: amd64 arm64
Depends:
 librocm-core1 (= ${binary:Version}),
 ${misc:Depends},
Description: provides methods to get information about installed ROCm - headers
 rocm-core can be used to get a ROCm release version in addition to other
 base information like install path.
 .
 rocm-core is not used by all ROCm components and may not provide an accurate
 value for versions if the other component packages are not updated at the
 same time.
 .
 This package provides the librocm-core1 development headers

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

CMAKE_FLAGS = \
	-DCMAKE_VERBOSE_MAKEFILE=1 \
	-DCPACK_DEB_COMPONENT_INSTALL=OFF \
	-DCPACK_RPM_COMPONENT_INSTALL=OFF \
	-DDISABLE_CPACK=ON \
	-DROCM_VERSION="6.4.4"

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- $(CMAKE_FLAGS)

=== debian/tests/control ===
Tests: rocm-core-path.sh
       rocn-core-version.sh
Depends: g++
         librocm-core-dev
Restrictions: superficial, skippable

=== debian/watch ===
version=4

opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%rocm-core-$1.tar.gz%" \
    https://github.com/rocm/rocm-core/tags \
    (?:.*?/)?rocm-v?(\d[\d.]*)\.tar\.gz debian

## rocm-core 7.1.0

=== debian/changelog ===
rocm-core (7.1.0-0ubuntu1) resolute; urgency=medium

  [ Tim Flink ]
  * d/salsa-ci.yml: adding config so that salsa ci runs for rocm-core
  * d/control: uncommenting Vcs-Browser and Vcs-Git

  [ Bojan Aleksovski ]
  * New upstream version rocm-core 7.1.0
  * d/control: update maintainer to ubuntu devel
  * d/control: enable ppc64el build

 -- Bojan Aleksovski <bojan.aleksovski@canonical.com>  Fri, 30 Jan 2026 12:50:29 +0100

rocm-core (6.4.4-1~exp6) experimental; urgency=medium

  * d/rules: use dpkg-parsechangelog instead of hard-coding required version
    information

 -- Tim Flink <Tim.Flink@amd.com>  Thu, 18 Dec 2025 13:43:28 -0600

rocm-core (6.4.4-1~exp5) UNRELEASED; urgency=medium

  * d/tests/control: fixing syntax of Depends for lintian warning
  * uncommenting Vcs-Browser, Vcs-Git
  * d/control: removing redundant rules-requires-root:no
  * d/watch: upgrading to watch file version 5

 -- Tim Flink <Tim.Flink@amd.com>  Wed, 17 Dec 2025 14:22:21 -0600

rocm-core (6.4.4-1~exp4) UNRELEASED; urgency=medium

  * changing build to be for experimental instead of unstable
  * fixing typo in d/tests/control
  * updating upstream URL to match current project and not project when this
    release was done

 -- Tim Flink <Tim.Flink@amd.com>  Wed, 17 Dec 2025 13:23:48 -0600

rocm-core (6.4.4-1~exp3) UNRELEASED; urgency=medium

  * bumping version for new build

 -- Tim Flink <Tim.Flink@amd.com>  Mon, 15 Dec 2025 20:50:23 -0600

rocm-core (6.4.4-1~exp2) UNRELEASED; urgency=medium

  * updates to address review comments
    - fixed naming of librocm-core-dev
    - fixed upstream URLs
    - removed uneeded Build-Depens
    - reworked descriptions
    - removed ppc64le builds
    - fixed build flags
    - build with system compiler instead of hipcc

 -- Tim Flink <Tim.Flink@amd.com>  Tue, 9 Dec 2025 13:21:14 -0700

rocm-core (6.4.4-1~exp1) UNRELEASED; urgency=medium

  * Initial package for rocm-core_6.4.4-1

 -- Tim Flink <Tim.Flink@amd.com>  Fri, 26 Sep 2025 19:27:31 -0600

=== debian/control ===
--- 
+++ 
@@ -1,20 +1,20 @@
 Source: rocm-core
 Section: devel
-Homepage: https://github.com/ROCm/rocm-core
+Homepage: https://github.com/ROCm/rocm-systems/tree/develop/projects/rocm-core
 Priority: optional
 Standards-Version: 4.7.2
-#Vcs-Browser: https://salsa.debian.org/rocm-team/rocm-core
-#Vcs-Git: https://salsa.debian.org/rocm-team/rocm-core.git
-Maintainer: Debian ROCm Team <debian-ai@lists.debian.org>
-Uploaders: Tim Flink <tflink@tirfa.com>
+Vcs-Browser: https://salsa.debian.org/rocm-team/rocm-core
+Vcs-Git: https://salsa.debian.org/rocm-team/rocm-core.git
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian ROCm Team <debian-ai@lists.debian.org>
+Uploaders: Tim Flink <Tim.Flink@amd.com>
 Build-Depends:
  debhelper-compat (= 13),
  cmake,
-Rules-Requires-Root: no
 
 Package: librocm-core1
 Section: libs
-Architecture: amd64 arm64
+Architecture: amd64 arm64 ppc64el
 Depends:
  ${shlibs:Depends},
  ${misc:Depends},
@@ -28,7 +28,7 @@
 
 Package: librocm-core-dev
 Section: libdevel
-Architecture: amd64 arm64
+Architecture: amd64 arm64 ppc64el
 Depends:
  librocm-core1 (= ${binary:Version}),
  ${misc:Depends},

=== debian/watch ===
Version: 5

# rocm-core has moved to https://github.com/ROCm/rocm-systems but those tags
# won't work for individual components. This will eventually need to be
# reworked but for now, keeping the watch file pointing at the old repo's tags
# since they are still being updated

Source: https://github.com/ROCm/rocm-core/tags
Matching-Pattern: (?:.*?/)?rocm-v?(\d[\d.]*)\.tar\.gz
Filenamemangle: s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%rocm-core-$1.tar.gz%
